"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreHandler = void 0;
var StoreHandler = /** @class */ (function () {
    function StoreHandler() {
    }
    //__________   SET    __________//
    StoreHandler.setState = function (state, _a) {
        var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
        var values = _a.values, scope = _a.scope;
        var Val = values ? values : {};
        var Sc = scope ? scope.split(".") : [];
        switch (Sc.length) {
            case 0:
                return __assign(__assign({}, state), Val);
            case 1:
                return __assign(__assign({}, state), (_b = {}, _b[Sc[0]] = __assign(__assign({}, state[Sc[0]]), Val), _b));
            case 2:
                return __assign(__assign({}, state), (_c = {}, _c[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_d = {}, _d[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), Val), _d)), _c));
            case 3:
                return __assign(__assign({}, state), (_e = {}, _e[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_f = {}, _f[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_g = {}, _g[Sc[2]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]]), Val), _g)), _f)), _e));
            case 4:
                return __assign(__assign({}, state), (_h = {}, _h[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_j = {}, _j[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_k = {}, _k[Sc[2]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]]), (_l = {}, _l[Sc[3]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]][Sc[3]]), Val), _l)), _k)), _j)), _h));
            case 5:
                return __assign(__assign({}, state), (_m = {}, _m[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_o = {}, _o[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_p = {}, _p[Sc[2]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]]), (_q = {}, _q[Sc[3]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]][Sc[3]]), (_r = {}, _r[Sc[4]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]][Sc[3]][Sc[4]]), Val), _r)), _q)), _p)), _o)), _m));
            default:
                return __assign({}, state);
        }
    };
    //__________   Clear    __________//
    StoreHandler.clearState = function (state, initState, _a) {
        var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r;
        var values = _a.values, scope = _a.scope;
        var Sc = scope ? scope.split(".") : [];
        var Val = values ? values : {};
        switch (Sc.length) {
            case 0:
                return __assign(__assign({}, initState), Val);
            case 1:
                return __assign(__assign({}, state), (_b = {}, _b[Sc[0]] = __assign(__assign({}, initState[Sc[0]]), Val), _b));
            case 2:
                return __assign(__assign({}, state), (_c = {}, _c[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_d = {}, _d[Sc[1]] = __assign(__assign({}, initState[Sc[0]][Sc[1]]), Val), _d)), _c));
            case 3:
                return __assign(__assign({}, state), (_e = {}, _e[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_f = {}, _f[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_g = {}, _g[Sc[2]] = __assign(__assign({}, initState[Sc[0]][Sc[1]][Sc[2]]), Val), _g)), _f)), _e));
            case 4:
                return __assign(__assign({}, state), (_h = {}, _h[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_j = {}, _j[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_k = {}, _k[Sc[2]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]]), (_l = {}, _l[Sc[3]] = __assign(__assign({}, initState[Sc[0]][Sc[1]][Sc[2]][Sc[3]]), Val), _l)), _k)), _j)), _h));
            case 5:
                return __assign(__assign({}, state), (_m = {}, _m[Sc[0]] = __assign(__assign({}, state[Sc[0]]), (_o = {}, _o[Sc[1]] = __assign(__assign({}, state[Sc[0]][Sc[1]]), (_p = {}, _p[Sc[2]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]]), (_q = {}, _q[Sc[3]] = __assign(__assign({}, state[Sc[0]][Sc[1]][Sc[2]][Sc[3]]), (_r = {}, _r[Sc[4]] = __assign(__assign({}, initState[Sc[0]][Sc[1]][Sc[2]][Sc[3]][Sc[4]]), Val), _r)), _q)), _p)), _o)), _m));
            default:
                return __assign({}, initState);
        }
    };
    return StoreHandler;
}());
exports.StoreHandler = StoreHandler;
